--******************************************************************************
--*  Functions v0.2b   part of Time Tracker for Max 4.2                        *
--*  (THIS IS A BETA VERSION, USE AT YOUE OWN RISK! DON'T USE FOR PRODUCTION)  *
--*                                                                            *
--*  by Ofer Zelichover (c) 02/2002                                            *
--*  www.tdp.nu/ofer   ;   ofer_z@hotmail.com                                  *
--*                                                                            *
--******************************************************************************
--*  You may use this script freely as you see fit.                            *
--*  You may use parts or the script as a whole in your own scripts.           *
--*  (it would be nice if you give me a credit if you do so ;))                *
--******************************************************************************
--*  This script comes with no waranty!                                        *
--*  Although I tried this script and couldn't find any problems with it, I can*
--*  in no way be held responsible for any kind of loss or damage, whether     *
--*  direct or indirect, due to the use of this script.                        *
--*                                                                            *
--*  ********************************************************************      *
--*  *** IF YOU DON'T LIKE THE ABOVE STATEMENT, DON'T USE THIS SCRIPT ***      *
--*  ********************************************************************      *
--*                                                                            *
--*  **** This script was written for max 4.2 and wasn't tested on other ****  *
--*  **** versions of max.                                               ****  *
--*                                                                            *
--*  If you find any bugs in this script, please let me know.                  *
--******************************************************************************
--* MODIFY AT YOUR OWN RISK!!!                                                 *
--******************************************************************************


-- print errors in debug mode
fn ttPrintError func err = (
	try(
		if ttSettings.debugMode then 
			format "timeTracker: %: %\n" func err
	)catch()
)

-- restore a session that wasn't properly closed because of a crash.
fn ttRestoreFromCrash = (
	local fName = ttSettings.baseDir + ttSettings.dataDir + "tmpSession.dat"
	if NOT doesFileExist fName then return()
	
	-- get the temp session info from the file.
	local t = time_struct hoursPerDay:ttSettings.hoursPerWorkDay
	local t24 = time_struct()
	local tmpSess = ttSession_struct settings:ttSettings
	tmpSess.startTime =	t24.strToTime (getINISetting fName "Current Session" "startTime")
	tmpSess.startDate = getINISetting fName "Current Session" "startDate"
	tmpSess.endTime = t24.strToTime (getINISetting fName "Current Session" "endTime")
	tmpSess.endDate = getINISetting fName "Current Session" "endDate"
	tmpSess.sessionTime = t.strToTime (getINISetting fName "Current Session" "sessionTime")
	tmpSess.user = getINISetting fName "Current Session" "user"
	tmpSess.projectID =	(getINISetting fName "Current Session" "projectID") as integer
	tmpSess.file = getINISetting fName "Current Session" "file"
	
	-- close and save the session.
	tmpSess.close()
	
	if tmpSess.projectID == undefined then return()
	
	local projFile = ttSettings.baseDir + ttSettings.dataDir + "projects.dat"
	local i = 0
	local n
	do (
		i += 1
		n = (getINISetting projFile ("Project_"+i as string) "<ID>") as integer
	) while (n!=undefined AND n!= tmpSess.projectID)
	t = t.strToTime (getINISetting projFile ("Project_"+i as string) "<totalTime>")
	t = t.add tmpSess.sessionTime
	setINISetting projFile ("Project_"+i as string) "<totalTime>" (t.timeToStr())
)


