--******************************************************************************
--*  smallDlg v0.21b   part of Time Tracker for Max 4.2                        *
--*  (THIS IS A BETA VERSION, USE AT YOUE OWN RISK! DON'T USE FOR PRODUCTION)  *
--*                                                                            *
--*  by Ofer Zelichover (c) 02/2002                                            *
--*  www.tdp.nu/ofer   ;   ofer_z@hotmail.com                                  *
--*                                                                            *
--******************************************************************************
--*  You may use this script freely as you see fit.                            *
--*  You may use parts or the script as a whole in your own scripts.           *
--*  (it would be nice if you give me a credit if you do so ;))                *
--******************************************************************************
--*  This script comes with no waranty!                                        *
--*  Although I tried this script and couldn't find any problems with it, I can*
--*  in no way be held responsible for any kind of loss or damage, whether     *
--*  direct or indirect, due to the use of this script.                        *
--*                                                                            *
--*  ********************************************************************      *
--*  *** IF YOU DON'T LIKE THE ABOVE STATEMENT, DON'T USE THIS SCRIPT ***      *
--*  ********************************************************************      *
--*                                                                            *
--*  **** This script was written for max 4.2 and wasn't tested on other ****  *
--*  **** versions of max.                                               ****  *
--*                                                                            *
--*  If you find any bugs in this script, please let me know.                  *
--******************************************************************************
--* MODIFY AT YOUR OWN RISK!!!                                                 *
--******************************************************************************


macroScript smallTracker
	category:"Time Tracker"
	buttonText:"smallTracker"
	tooltip:"Time Tracker - Small Dialog"
(

--*****************************************************************************
-- Small Dialog
--*****************************************************************************

	rollout ro_ttSmallDlg "timeTracker"
	(
	-- Local Functions Declerations
	---------------------------------
		local generateBitmaps
		local ttRestorePressed = false


	-- Local Variables Declerations
	---------------------------------
		local ttTickInterval = try(ttSettings.tickInterval)catch(60*1000)
		local bm = generateBitmaps (color 255 100 100) (color 30 220 30) 14 14

	-- GUI
	--------
		checkbutton ttTrackOnOff images:#(bm, undefined, 2, 1, 2, 1, 2) height:16 width:16 pos:[1,1] tooltip:"Tracking On/Off."
		label ttTimeDisplay "" width:65 pos:[21,3]
		button ttRestore "Restore" height:16 width:45 pos:[86,1] tooltip:"Restore dialog to original size."
		
		timer ttTimer interval:ttTickInterval active:(ttCurSess.trackingOn)
	
	-- Functions
	---------------
		fn generateBitmaps col1 col2 w h= (
			local b = bitmap (w*2) h color:col1
			for y = 0 to (h-1) do (
				setPixels b [w,y] (for x = 1 to w collect col2)				
			)
			b
		)

		fn updateTimeDisplay = (
			ttTimeDisplay.text = try(ttCurSess.sessionTime.timeToStr())catch("")
		)

		fn updateGUI = (
			ttTrackOnOff.checked = ttCurSess.trackingOn
			ttTrackOnOff.enabled = ttCurSess.projectID!=undefined
			updateTimeDisplay()
		)

		fn doTick = (
			-- update the session time and save to the tmpSession file.
			ttCurSess.sessionTime = ttCurSess.sessionTime.add (ttTickInterval/1000)
			ttCurSess.saveTemp()
			
			-- update the UI to show the session statistics.
			updateTimeDisplay()
		)

		fn init = (
			local fName = ttSettings.baseDir + "timeTracker.ini"
			try (
				local arr = filterString (getINISetting fName "Settings" "smallDialogPos") "[,]"
				ttSettings.smallDialogPos = [(arr[1] as integer) ,(arr[2] as integer)]
			)catch()
			setDialogPos ro_ttSmallDlg ttSettings.smallDialogPos

			ttRestorePressed = false
			
			if ttCurSess.projectID==undefined OR ttCurSess.user==undefined then
				ttGenFuncs.updateCurSess()
			
			updateGUI()
			freeSceneBitmaps()
			gc()
		)
		
		fn done = (
			if NOT ttRestorePressed then
				ttCurSess.trackingOn = false
			
			-- save the pos in the ini file.
			local fName = ttSettings.baseDir + "timeTracker.ini"
			if ttSettings.smallDialogPos != undefined then
				setINISetting fName "Settings" "smallDialogPos" (ttSettings.smallDialogPos as string)

			-- clean up
			freeSceneBitmaps()
			gc()
		)
	
	-- Event Handlers
	-------------------
		on ttRestore pressed do (
			ttRestorePressed = true
			if ro_ttCurrentSession==undefined OR NOT ro_ttCurrentSession.open then
				macros.run "Time Tracker" "timeTracker"
			destroyDialog ro_ttSmallDlg
		)
		
		on ttTrackOnOff changed state do (
			ttCurSess.trackingOn = state
			ttTimer.active = state
			try(ro_ttCurrentSession.changeTrackOnOff state)catch()
		)
		
		on ttTimer tick do (
			if ttCurSess.trackingOn AND NOT ro_ttCurrentSession.open then doTick()
		)
	
		on ro_ttSmallDlg moved pos do (
			ttSettings.smallDialogPos = getDialogPos ro_ttSmallDlg
		)
		
		on ro_ttSmallDlg OkToClose return (
			(ro_ttCurrentSession!=undefined AND ro_ttCurrentSession.open) OR \
			(NOT ttSettings.askBeforeQuit) OR \
			(queryBox "Quit Time Tracker?\n(tracking will stop)" title:"Time Tracker")
		)
	
		on ro_ttSmallDlg open do init()
		on ro_ttSmallDlg close do done()
	) -- end of ro_ttSmallDlg
	
--*****************************************************************************
	on execute do (
		try (destroyDialog ro_ttSmallDlg)catch()
		local p = try(ttSettings.smallDialogPos)catch([10,500])
		if p==undefined then p = [10,500]
		createDialog ro_ttSmallDlg height:10 width:132 pos:p style:#(#style_toolWindow, #style_sysMenu)
	)
)-- end macroScript